package ca.recrown.islandsurvivalcraft.interaction.items;

import java.nio.charset.StandardCharsets;

import org.bukkit.persistence.PersistentDataAdapterContext;
import org.bukkit.persistence.PersistentDataType;

public class VariationItemIdentifier implements PersistentDataType<byte[], String> {
    private final String ID;

    public VariationItemIdentifier(String ID) {
        this.ID = ID;
    }

    @Override
    public Class<byte[]> getPrimitiveType() {
        return byte[].class;
    }

    @Override
    public Class<String> getComplexType() {
        return String.class;
    }

    @Override
    public byte [] toPrimitive(String complex, PersistentDataAdapterContext context) {
        return complex.getBytes(StandardCharsets.UTF_8);
    }

    @Override
    public String fromPrimitive(byte [] primitive, PersistentDataAdapterContext context) {
        return new String(primitive, StandardCharsets.UTF_8);
    }
    
    /**
     * @return the iD
     */
    public String getID() {
        return ID;
    }
}